
clear
close all



ramp_data = load('parameters.matlab');

rampStartTimeHeave        = 0.0;
rampDurationHeave         = ramp_data(2);
rampEndTimeHeave          = rampStartTimeHeave + rampDurationHeave;
rampStartValueHeave       = 0.0;
finalHeaveAmp = ramp_data(1);    
heaveOmega    = ramp_data(3);  
heavePhase    = 0.0; 

folders = dir('postProcessing/moonpoolfreesurface/');
    
    t=1;
    for i = 3:length(folders)
        foldername = folders(i).name;
        file = strcat('postProcessing/moonpoolfreesurface/',foldername,'/p_gh_freeSurface.raw');
        if exist(file, 'file')     
        fileID = fopen(file);  
        C = textscan(fileID,'%f %f %f %f','CommentStyle','#');
        fclose(fileID);
        elevation = C{1,4}(1:10) / 9.81;
        time(t) = str2num(folders(i).name);
        stat_mean(t) = mean(elevation);
        end
        t=t+1;
    end
    
    
[mean_time order] = sort(time);
 mean_surface = stat_mean(order);
 
figure();
plot(mean_time,mean_surface)
title('Moonpool Elevation Mean')
legend('Moonpool','Hull')
print('Moonpool Elevation','-dpng')
 
 
 b = length(time);
 a = round(0.5*b);
 
extracted_data = mean_surface(a:b);
extracted_time = mean_time(a:b);
isOctave = exist('OCTAVE_VERSION', 'builtin') ~= 0;
if isOctave
    pkg load signal
    extracted_data = (extracted_data + abs(extracted_data))*0.5;
    [pks_data loc_data] = findpeaks(extracted_data); 
else
    [pks_data loc_data] = findpeaks(extracted_data); 
end

mean_of_all = mean(pks_data);
dimless_amp = mean_of_all/finalHeaveAmp

if isempty(mean_of_all)
    mean_of_all = 0;
    dimless_amp = 0
end;

fileID = fopen('../free_surface_data.txt','a+');
fprintf(fileID,'%.4f %.4f %.4f \n',heaveOmega,mean_of_all,dimless_amp);
fclose(fileID);




