
clear
close all


live_plot = 0;
d_plot = 0.2;

ramp_data = load('parameters.matlab');

rampStartTimeHeave        = 0.0;
rampDurationHeave         = ramp_data(2);
rampEndTimeHeave          = rampStartTimeHeave + rampDurationHeave;
rampStartValueHeave       = 0.0;
finalHeaveAmp = ramp_data(1);    
heaveOmega    = ramp_data(3);  
heavePhase    = 0.0; 
    
sample_times = dir('postProcessing/moonpoolfreesurface/');
samples = size(sample_times,1) - 2;

t=1;
for i = 3:samples
 time_dummy(t) = str2num(sample_times(i).name);
 t=t+1;
end

[dummy indices]=sort(time_dummy);


file = strcat('postProcessing/moonpoolfreesurface/',num2str(time_dummy(3)),'/p_gh_moonpool_water_surface.raw');
fileID = fopen(file);  
C = textscan(fileID,'%f %f %f %f','CommentStyle','#');
fclose(fileID);

x = C{1,1};

hull_bottom = zeros(1,length(x));


t=1;
for j = 1:length(indices)
    
    i = indices(j)+2;

    foldername = sample_times(i).name;
    
    file = strcat('postProcessing/moonpoolfreesurface/',foldername,'/p_gh_moonpool_water_surface.raw');
    fileID = fopen(file);  
    C = textscan(fileID,'%f %f %f %f','CommentStyle','#');
    fclose(fileID);
    y = C{1,4} / 9.81;

    if live_plot == 1

    plot(x,y,'*',x,hull_bottom,'r')
    axis([min(x) max(x) -d_plot d_plot]);
    title(strcat('Time - ',foldername))
    pause(0.01);

    end

    time(t) = str2num(sample_times(i).name);
    stat_mean(t) = mean(y);
    stat_max(t) = max(y);
    stat_min(t) = min(y);
    
    if time(t) < rampStartTimeHeave
        heaveaAmp = 0;
    elseif time(t) < (rampEndTimeHeave)
        heaveaAmp = (finalHeaveAmp - rampStartValueHeave)/rampDurationHeave * (time(t)  - rampStartTimeHeave) + rampStartValueHeave;
    else
        heaveaAmp = finalHeaveAmp;
    end
    
    %confirmed
    heave_force(t) = heaveaAmp * cos(heaveOmega * time(t) + heavePhase); 
            
    t=t+1;
end

figure();
plot(x,y,'*',x,hull_bottom,'r')
axis([min(x) max(x) -d_plot d_plot]);
title(strcat('Time - ',foldername))

figure();
plot(time,stat_mean,time,heave_force)
title('Moonpool Elevation Mean')
legend('Moonpool','Hull')
print('figures/Moonpool Elevation','-dpng')

isOctave = exist('OCTAVE_VERSION', 'builtin') ~= 0;

for i = 1:size(time,2)
    if time(i) > (ramp_data(2)*(2.8/2))
        break
    end
end

a = i

for i = 1:size(time,2)
    if time(i) > (ramp_data(2)*(7.2/2))
        break
    end
end

b= i
        
extracted_data = stat_mean(a:b);
extracted_time = time(a:b);


if isOctave
    pkg load signal
    extracted_data = (extracted_data + abs(extracted_data))*0.5;
    [pks_data loc_data] = findpeaks(extracted_data); 
    
    heave_force(a:b) = (heave_force(a:b) + abs(heave_force(a:b)))*0.5;
    [pks_force loc_force] = findpeaks(heave_force(a:b)); 
else
    [pks_data loc_data] = findpeaks(extracted_data); 
    [pks_force loc_force] = findpeaks(heave_force(a:b)); 
end

mean_of_all = mean(pks_data)
dimless_amp = mean_of_all/finalHeaveAmp


fileID = fopen('free_surface_data.txt','w+');
fprintf(fileID, '\n');
fprintf(fileID,'Mean %.4f \n',mean_of_all);
fprintf(fileID,'dimless_Amp %.4f \n',dimless_amp);
fclose(fileID);


fileID = fopen('../free_surface_data.txt','a+');
fprintf(fileID,'%.4f %.4f %.4f %.4f %.4f \n',heaveOmega,mean_of_all,dimless_amp,max(stat_mean),(max(stat_mean)/finalHeaveAmp));
fclose(fileID);




