/*--------------------------------*- C++ -*----------------------------------*\
| =========                 |                                                 |
| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |
|  \\    /   O peration     | Version:  2.2.1                                 |
|   \\  /    A nd           | Web:      www.OpenFOAM.org                      |
|    \\/     M anipulation  |                                                 |
\*---------------------------------------------------------------------------*/
FoamFile
{
    version     2.0;
    format      ascii;
    class       dictionary;
    location    "system";
    object      controlDict;
}
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

changecom(//)changequote([,]) dnl>
define(calc, [esyscmd(perl -e 'use Math::Trig; print ($1)')]) dnl>
include(parameters.m4)
define(wall_cofr,(calc(For_ship+0.5*B) -D 0.0))
define(moonpool_cofr,(calc(For_ship+0.5*B) calc(-0.5*D) 0.0))

define(probe_temp1, calc(For_ship-B))
define(probe_temp2, calc(For_ship+B))
define(probe_temp3, calc(-B*2))

define(write_interval, calc(para_logInterval/para_deltaT))


application     pimpleFoam;

startFrom       startTime;

startTime       para_startTime;

stopAt          endTime;

endTime         para_endTime;

deltaT          para_deltaT;

writeControl    adjustableRunTime;

writeInterval   para_writeInterval;

purgeWrite      0;

writeFormat     binary;

writePrecision  6;

writeCompression uncompressed;

timeFormat      general;

timePrecision   6;

runTimeModifiable no;

adjustTimeStep  no;

maxCo           0.6;

maxDeltaT       0.1;


functions
{
    probes
    { 
        type probes; 
        functionObjectLibs ("libsampling.so"); 
        outputControl timeStep;
        outputInterval write_interval;
        probeLocations 
        ( 
        (probe_temp1 probe_temp3 0.0) 
        (probe_temp2 probe_temp3 0.0) 
        ); 

        fields ( U ); 

    }
    moonpoolfreesurface
    {
        type surfaces;
        functionObjectLibs ( "libsampling.so" );
        enabled true;
        outputControl timeStep;
        outputInterval write_interval;
        surfaceFormat raw;
        interpolationScheme cell;
        fields ( p_gh );
        surfaces
        (
        moonpool_water_surface
        {
        type patch;
        patches (moonpool_water_surface);
        }
        );
    }
    forceHull
    {
        type            forces;
        functionObjectLibs ("libforces.so");
        outputControl timeStep;
        outputInterval write_interval;
        patches         (
        		"hull.*"
        		);
        pName           p;
        UName           U;
        rhoName         rhoInf;
        log             no;
        rhoInf          1000;
        CofR            wall_cofr;
    }
	pressureMoonpool_Upstream_Wall
    {
        type surfaces;
        functionObjectLibs ( "libsampling.so" );
        enabled true;
        outputControl timeStep;
        outputInterval 4;
        surfaceFormat raw;
        interpolationScheme cell;
        fields ( p );
        surfaces
        (
        moonpool_wall2
        {
        type patch;
        patches (moonpool_wall2);
        }
        );
    }
    pressureMoonpool_Downstream_Wall
    {
        type surfaces;
        functionObjectLibs ( "libsampling.so" );
        enabled true;
        outputControl timeStep;
        outputInterval 4;
        surfaceFormat raw;
        interpolationScheme cell;
        fields ( p );
        surfaces
        (
        moonpool_wall1
        {
        type patch;
        patches (moonpool_wall1);
        }
        );
    }
    	
}


};

// ************************************************************************* //
