
clear
close all

cats = size(dir(('postProcessing/sets/')));
c = cats(1);
c = c-2; % . & ..

%load('parameters.matlab',geo_moonpool_depth,case_OFpara_startTime,case_OFpara_endTime,case_OFpara_deltaT,case_OFpara_writeInterval)
case_data = load('parameters.matlab');

d_plot = 2*case_data(2);

log_interval = case_data(17);
log_interval = floor(log_interval*10000)/10000

start_time = case_data(13)+log_interval;
end_time = case_data(14);

file = strcat('postProcessing/moonpoolfreesurface/',num2str(log_interval),'/p_gh_moonpool_water_surface.raw');
fileID = fopen(file);  
C = textscan(fileID,'%f %f %f %f','CommentStyle','#');
fclose(fileID);

x = C{1,1};

hull_bottom = zeros(1,length(x));

live_plot = 0;

t=1;
for i = start_time:log_interval:end_time

    foldername = num2str(i,6);
    
    file = strcat('postProcessing/moonpoolfreesurface/',foldername,'/p_gh_moonpool_water_surface.raw');
    fileID = fopen(file);  
    C = textscan(fileID,'%f %f %f %f','CommentStyle','#');
    fclose(fileID);
    y = C{1,4} / 9.81;

    if live_plot == 1 

    plot(x,y,x,hull_bottom,'r')
    axis([min(x) max(x) -d_plot d_plot]);
    title(strcat('Time - ',num2str(i)))
    pause(0.01);

    end

    
    stat_mean(t) = mean(y);
    stat_max(t) = max(y);
    stat_min(t) = min(y);
    t=t+1;
    
end

temp_max = ceil(max(stat_max*100))
temp_min = abs(floor(min(stat_min*100)))

if temp_max > temp_min
    d_plot = temp_max/100;
else
    d_plot =temp_min/100;
end

time = start_time:log_interval:end_time;
figure()
plot(time,stat_mean)
axis([min(time) max(time) -d_plot d_plot]);
figure()
plot(time,stat_max)
axis([min(time) max(time) -d_plot d_plot]);
figure()
plot(time,stat_min)
axis([min(time) max(time) -d_plot d_plot]);

figure();
plot(time,stat_mean,time,stat_max,time,stat_min)
title('Moonpool Elevation')
legend('Mean','Max','Min')
axis([min(time) max(time) -d_plot d_plot]);
print('figures/Moonpool Elevation','-dpng')

close all

figure();
plot(time,stat_mean,time,stat_max,time,stat_min)
title('Moonpool Elevation Time Last Half')
legend('Mean','Max','Min')
axis([(0.5*max(time)) max(time) -d_plot d_plot]);
print('figures/Moonpool Elevation Time Last Half','-dpng')

isOctave = exist('OCTAVE_VERSION', 'builtin') ~= 0;

if isOctave

    pkg load signal

    a = (0.5*max(time));
    b = (1.0*max(time));

    fileID = fopen('figures/free_surface_data.txt','w');

    [pks, loc] = findpeaks(stat_mean(a:b),'DoubleSided');
    pos = [];
    neg = [];
    for i=1:length(pks)
        if pks(i)>=0
            pos = [pos pks(i)];
        else
            neg = [neg pks(i)];
        end
    end

    mean_pos = mean(pos)
    
    temp = pos - mean_pos;
    r_pos = max(abs(temp))

    r_pos_over_mean = r_pos/mean_pos

    mean_neg = mean(neg)

    temp = neg - mean_neg;
    r_neg = max(abs(temp))

    r_neg_over_mean = r_neg/mean_neg

    fprintf(fileID, '#   Mean R+ R- R_tot R+/mean R-/mean \n');
    fprintf(fileID,'Mean %.4f %.4f %.4f %.4f %.4f %.4f \n',mean_pos,r_pos,r_neg,mean(r_neg+r_neg),r_neg_over_mean,r_pos_over_mean);

    [pks, loc] = findpeaks(stat_max(a:b),'DoubleSided');
    pos = [];
    neg = [];
    for i=1:length(pks)
        if pks(i)>=0
            pos = [pos pks(i)];
        else
            neg = [neg pks(i)];
        end
    end

    mean_pos = mean(pos)
    
    temp = pos - mean_pos;
    r_pos = max(abs(temp))

    r_pos_over_mean = r_pos/mean_pos

    mean_neg = mean(neg)

    temp = neg - mean_neg;
    r_neg = max(abs(temp))

    r_neg_over_mean = r_neg/mean_neg


    fprintf(fileID,'Max %.4f %.4f %.4f %.4f %.4f %.4f \n',mean_pos,r_pos,r_neg,mean(r_neg+r_neg),r_neg_over_mean,r_pos_over_mean);


    [pks, loc] = findpeaks(stat_min(a:b),'DoubleSided');
    pos = [];
    neg = [];
    for i=1:length(pks)
        if pks(i)>=0
            pos = [pos pks(i)];
        else
            neg = [neg pks(i)];
        end
    end

    mean_pos = mean(pos)
    
    temp = pos - mean_pos;
    r_pos = max(abs(temp))

    r_pos_over_mean = r_pos/mean_pos

    mean_neg = mean(neg)

    temp = neg - mean_neg;
    r_neg = max(abs(temp))

    r_neg_over_mean = r_neg/mean_neg

    fprintf(fileID,'Min %.4f %.4f %.4f %.4f %.4f %.4f \n',mean_pos,r_pos,r_neg,mean(r_neg+r_neg),r_neg_over_mean,r_pos_over_mean);

    fclose(fileID);

end
